import {Injectable} from '@angular/core';

@Injectable({providedIn: 'root'})
export class ToastService {
    private controller: HTMLAnjToastControllerElement;

    public static createController(): HTMLAnjToastControllerElement {
        const controller = document.createElement('anj-toast-controller');
        document.body.appendChild(controller);
        return controller as HTMLAnjToastControllerElement;
    }

    constructor() {
        this.controller = document.querySelector('anj-toast-controller') || ToastService.createController();
    }

    public dismissAll(): void {
        this.controller.dismissAll();
    }

    public error(message: string, header?: string): Promise<HTMLAnjToastElement> {
        return this.controller.error(message, header);
    }

    public message(message: string, header?: string): Promise<HTMLAnjToastElement> {
        return this.controller.message(message, header);
    }

    public success(message: string, header?: string): Promise<HTMLAnjToastElement> {
        return this.controller.success(message, header);
    }

    public warn(message: string, header?: string): Promise<HTMLAnjToastElement> {
        return this.controller.warn(message, header);
    }
}
