## The Basics

At its heart all the transition directive needs is some form of state modifier and then css classes to go with it.

```sass
.anj-dfade-enter-active,
.anj-dfade-leave-active {
    transition: opacity $animation-length-long-in;
}

.anj-dfade-enter-to,
.anj-dfade-leave {
    opacity: 0;
}

.anj-dfade-enter {
    opacity: 1;
}
```

```html
<div class="dummy-block" [anjTransition]="fadeState" name="dfade">
    Fade In/Out
</div>
<div class="buttons-wrapper">
    <span class="btn btn-primary" (click)="fadeState = 'In'">In</span>
    <span class="btn btn-secondary" (click)="fadeState = null">Out</span>
</div>
```
