import {DateValidatorDirective} from '@anjuna/angular-core';

const mockControl: any = {
    value: null
};

describe('directive: validator date', () => {
    let directive: DateValidatorDirective;

    beforeEach(() => {
        directive = new DateValidatorDirective();
    });

    it('should exist', () => {
        expect(typeof(directive)).not.toBe('undefined');
    });

    it('should return null when the control has a value of true', () => {
        mockControl.value = new Date();
        const error = directive.validate(mockControl);

        expect(error).toEqual(null);
    });

    it('should return undefined when the control has a value of null', () => {
        mockControl.value = null;
        const error = directive.validate(mockControl);

        expect(error).toEqual(undefined);
    });

    it('should return an error object when the control has a value of false', () => {
        mockControl.value = 'steve';
        const error = directive.validate(mockControl);

        expect(error).toEqual({
            date: {
                valid: false
            }
        });
    });
});
