import {DatePipe} from '@angular/common';

import {ZuoraDatePipe} from '@anjuna/angular-core';

describe('pipe: ZuoraDatePipe', () => {
    const datePipe: DatePipe = new DatePipe('en');
    const pipe: ZuoraDatePipe = new ZuoraDatePipe(datePipe);

    it('should convert a date object into an shortDate', () => {
        const testDate = new Date(2018, 3, 1);
        const output: string = pipe.transform(testDate);

        expect(output).toEqual('4/1/18');
    });

    it('should return undefined if not provided a date object', () => {
        const testDate = 'i am not a date';
        const output: any = pipe.transform(testDate);

        expect(output).toEqual(undefined);
    });

});
