import {RequiredCheckDirective} from '@anjuna/angular-core';

const mockControl: any = {
    value: null
};

describe('directive: validator required-check', () => {
    let directive: RequiredCheckDirective;

    beforeEach(() => {
        directive = new RequiredCheckDirective();
    });

    it('should exist', () => {
        expect(typeof directive).not.toBe('undefined');
    });

    it('should return null when the control has a value of true', () => {
        mockControl.value = true;
        const error = directive.validate(mockControl);

        expect(error).toEqual(null);
    });

    it('should return an error object when the control has a value of false', () => {
        mockControl.value = false;
        const error = directive.validate(mockControl);

        expect(error).toEqual({
            required: {
                valid: false
            }
        });
    });

    it('should return an error object when the control has a value of null', () => {
        mockControl.value = null;
        const error = directive.validate(mockControl);

        expect(error).toEqual({
            required: {
                valid: false
            }
        });
    });
});
