import {TestBed, inject} from '@angular/core/testing';

import {ToastService} from '@anjuna/angular-core';
import {mockToastController} from '@anjuna/angular-core/testing';

describe('service: ToastService', () => {
    beforeEach(() => {
        TestBed.configureTestingModule({
            providers: [
                ToastService,
            ]
        });
    });

    it('should be created', inject([ToastService], (service: ToastService) => {
        expect(service).toBeTruthy();
    }));

    it('should create the controller', inject([ToastService], (service: ToastService) => {
        const ser = service as any;
        expect(ser.controller).toBeTruthy();
    }));

    it('should not create the controller if it exists', inject([ToastService], (service: ToastService) => {
        const ser = service as any;
        const ser1 = new ToastService() as any;
        expect(ser1.controller).toEqual(ser.controller);
    }));

    it('should proxy error toast creation', inject([ToastService], (service: ToastService) => {
        const ser = service as any;
        ser.controller = mockToastController;
        spyOn(ser.controller, 'error');
        service.error('Danger toast');
        expect(ser.controller.error).toHaveBeenCalledWith('Danger toast', undefined);

        service.error('Danger toast', 'Header');
        expect(ser.controller.error).toHaveBeenCalledWith('Danger toast', 'Header');
    }));

    it('should proxy message toast creation', inject([ToastService], (service: ToastService) => {
        const ser = service as any;
        ser.controller = mockToastController;
        spyOn(ser.controller, 'message');
        service.message('Message toast');
        expect(ser.controller.message).toHaveBeenCalledWith('Message toast', undefined);

        service.message('Message toast', 'Header');
        expect(ser.controller.message).toHaveBeenCalledWith('Message toast', 'Header');
    }));

    it('should proxy success toast creation', inject([ToastService], (service: ToastService) => {
        const ser = service as any;
        ser.controller = mockToastController;
        spyOn(ser.controller, 'success');
        service.success('Success toast');
        expect(ser.controller.success).toHaveBeenCalledWith('Success toast', undefined);

        service.success('Success toast', 'Header');
        expect(ser.controller.success).toHaveBeenCalledWith('Success toast', 'Header');
    }));

    it('should proxy warning toast creation', inject([ToastService], (service: ToastService) => {
        const ser = service as any;
        ser.controller = mockToastController;
        spyOn(ser.controller, 'warn');
        service.warn('Warning toast');
        expect(ser.controller.warn).toHaveBeenCalledWith('Warning toast', undefined);

        service.warn('Warning toast', 'Header');
        expect(ser.controller.warn).toHaveBeenCalledWith('Warning toast', 'Header');
    }));

    it('should proxy dismissing all', inject([ToastService], (service: ToastService) => {
        const ser = service as any;
        ser.controller = mockToastController;
        spyOn(ser.controller, 'dismissAll');
        service.dismissAll();
        expect(ser.controller.dismissAll).toHaveBeenCalled();
    }));
});
