import {Component, ViewChild} from '@angular/core';
import {FormBuilder, FormControl, FormGroup} from '@angular/forms';

import {BooleanValueDirective, AnjunaValidators} from '@anjuna/angular-core';

@Component({
    template: `
        <form>
            <anj-checkbox required>This is required</anj-checkbox>
            <anj-button type="submit">Submit</anj-button>
        </form>`
})
export class StubBooleanValueComponent {
    @ViewChild(BooleanValueDirective) public directive: BooleanValueDirective;
}

@Component({
    template: `
        <form>
            <anj-checkbox [(ngModel)]="myValue" name="myRequiredThing" required>This is required</anj-checkbox>
            <anj-button type="submit">Submit</anj-button>
        </form>`
})
export class StubBooleanValueNGMComponent {
    @ViewChild(BooleanValueDirective) public directive: BooleanValueDirective;

    public myValue = false;
}

@Component({
    template: `
        <form [formGroup]="thingsForm">
            <anj-checkbox name="requiredThing" [formControl]="myThings" required>This is required</anj-checkbox>
            <anj-button-group>
                <anj-button type="submit">Submit</anj-button>
            </anj-button-group>
        </form>
    `
})
export class StubBooleanValueMDComponent {
    @ViewChild(BooleanValueDirective) public directive: BooleanValueDirective;

    public thingsForm: FormGroup;
    public myThings: FormControl;

    constructor(private builder: FormBuilder) {
        this.myThings = new FormControl(false, AnjunaValidators.requiredCheck);
        this.thingsForm = builder.group({
            myThings: this.myThings
        });
    }
}

