import {Component, ViewChild} from '@angular/core';
import {FormBuilder, FormControl, FormGroup} from '@angular/forms';

import {DatePickerDirective} from '@anjuna/angular-core/lib/forms/directives/date-picker.directive';
import {DateAdapter} from '@anjuna/angular-core';

@Component({
    template: `
<form autocomplete="off">
    <anj-form-group>
        <anj-input
            anjFormControl
            name="basicInput"
            placeholder="MM/DD/YYYY"
            anjDatePicker
            [(ngModel)]="basicDate">
            <anj-date-picker></anj-date-picker>
        </anj-input>
    </anj-form-group>
</form>`
})
export class StubDatePickerNGMComponent {
    @ViewChild(DatePickerDirective) public directive: DatePickerDirective;

    public basicDate = new Date();
}

@Component({
    template: `
        <form [formGroup]="surfboardForm" autocomplete="off">
            <anj-form-group>
                <anj-label>MM/DD/YYYY</anj-label>
                <anj-input
                    anjDatePicker
                    anjFormControl
                    [formControl]="manufacturedDate">
                    <anj-date-picker [adapter]="adapter"></anj-date-picker>
                </anj-input>
            </anj-form-group>
        </form>
    `
})
export class StubDatePickerMDComponent {
    @ViewChild(DatePickerDirective) public directive: DatePickerDirective;

    public surfboardForm: FormGroup;
    public manufacturedDate: FormControl;

    constructor(public adapter: DateAdapter<Date>,  builder: FormBuilder) {
        this.manufacturedDate = new FormControl(
            new Date(2018, 5, 15)
        );

        this.surfboardForm = builder.group({
            manufacturedDate: this.manufacturedDate
        });
    }
}

@Component({
    template: `
        <anj-input
            anjDatePicker>
            <anj-date-picker [adapter]="adapter"></anj-date-picker>
        </anj-input>
    `
})
export class StubDatePickerNoParentNoControlComponent {
    @ViewChild(DatePickerDirective) public directive: DatePickerDirective;
}
