import {Component, ViewChild} from '@angular/core';
import {FormBuilder, FormControl, FormGroup} from '@angular/forms';

import {AnjunaValidators} from '@anjuna/angular-core';
import {InputValueDirective} from '@anjuna/angular-core/lib/forms/directives/input-value.directive';

@Component({
    template: `
        <form>
            <anj-input required></anj-input>
            <anj-button type="submit">Submit</anj-button>
        </form>`
})
export class StubInputValueComponent {
    @ViewChild(InputValueDirective) public directive: InputValueDirective;
}

@Component({
    template: `
        <form>
            <anj-input [(ngModel)]="myValue" name="myRequiredThing" required></anj-input>
            <anj-button type="submit">Submit</anj-button>
        </form>`
})
export class StubInputValueNGMComponent {
    @ViewChild(InputValueDirective) public directive: InputValueDirective;

    public myValue = false;
}

@Component({
    template: `
        <form [formGroup]="thingsForm" (ngSubmit)="handleSubmit()">
            <anj-input name="requiredThing" [formControl]="myThings" required></anj-input>
            <anj-button-group>
                <anj-button type="submit">Submit</anj-button>
            </anj-button-group>
        </form>
    `
})
export class StubInputValueMDComponent {
    @ViewChild(InputValueDirective) public directive: InputValueDirective;

    public thingsForm: FormGroup;
    public myThings: FormControl;

    constructor(private builder: FormBuilder) {
        this.myThings = new FormControl(false, AnjunaValidators.requiredCheck);
        this.thingsForm = builder.group({
            myThings: this.myThings
        });
    }
}

