import {Component, ViewChild} from '@angular/core';
import {TimePickerDirective} from '@anjuna/angular-core/lib/forms/directives/time-picker.directive';

@Component({
    template: `
<form autocomplete="off">
    <anj-form-group>
        <anj-input
            anjFormControl
            name="basicInput"
            anjTimePicker
            [(ngModel)]="basicTime">
            <anj-time-picker></anj-time-picker>
        </anj-input>
    </anj-form-group>
</form>`
})
export class StubTimePickerComponent {
    @ViewChild(TimePickerDirective) public directive: TimePickerDirective;

    public basicTime = '11:15AM';
}

@Component({
    template: `
<form autocomplete="off">
    <anj-form-group>
        <anj-input anjTimePicker>
            <anj-time-picker></anj-time-picker>
        </anj-input>
    </anj-form-group>
</form>`
})
export class StubTimePickerNoControlComponent {
    @ViewChild(TimePickerDirective) public directive: TimePickerDirective;
}
