import {Component, ViewChildren, QueryList, ViewChild, ElementRef} from '@angular/core';

import {TransitionDirective, TransitionState} from '@anjuna/angular-core';

@Component({
    template: `
        <div #el1 class="dummy-block block1" [anjTransition]="state1" (onEnd)="handleEnd($event)">Fade In/Out</div>
        <div #el2 class="dummy-block block2" [anjTransition]="state2" name="test" (onEnd)="handleEnd($event)" mode="in">Fade In/Out</div>`
})
export class StubTransitionComponent {

    @ViewChildren(TransitionDirective) public directives: QueryList<TransitionDirective>;

    @ViewChild('el1') public el1: ElementRef;
    @ViewChild('el2') public el2: ElementRef;

    public state1: string;
    public state2: string;

    public handleEnd(state: TransitionState) {
        return true;
    }
}
